#include <stdio.h>
#include <stdlib.h>

int CompareX(const void *a, const void *b){
    int x1 = ((int*)a)[0], y1 = ((int*)a)[1];
    int x2 = ((int*)b)[0], y2 = ((int*)b)[1];
    return x1 != x2 ? x1 - x2 : y1 - y2;
}

int CompareY(const void *a, const void *b){
    int x1 = ((int*)a)[0], y1 = ((int*)a)[1];
    int x2 = ((int*)b)[0], y2 = ((int*)b)[1];
    return y1 != y2 ? y1 - y2 : x1 - x2;
}

int LowerBound(int *a, int l, int r, int v){
    if(a[r] < v) return r + 1;
    while(l < r){
        int m = (l + r) / 2;
        if(a[m] >= v) r = m;
        else l = m + 1;
    }
    return r;
}

int UpperBound(int *a, int l, int r, int v){
    if(a[r] <= v) return r + 1;
    while(l < r){
        int m = (l + r) / 2;
        if(a[m] > v) r = m;
        else l = m + 1;
    }
    return r;
}

long long Get(int *pos, long long *sum, int s, int e, int l, int r){
    int st = LowerBound(pos, s, e, l), ed = UpperBound(pos, s, e, r) - 1;
    if(st <= ed) return sum[ed] - (st > 0 ? sum[st-1] : 0);
    else return 0;
}

int N, Q, A[202020][3];
int XL[202020], XR[202020], YL[202020], YR[202020];
int XP[202020], YP[202020];
long long XS[202020], YS[202020];

int main(){
    scanf("%d %d", &N, &Q);
    for(int i=1; i<=N; i++) for(int j=0; j<3; j++) scanf("%d", &A[i][j]);

    qsort(A+1, N, sizeof(A[1]), CompareX);
    for(int i=1; i<=N; i++){
        if(A[i-1][0] != A[i][0]) XL[A[i][0]] = i;
        XR[A[i][0]] = i;
        XP[i] = A[i][1];
        XS[i] = A[i][2];
    }
    for(int i=1; i<=N; i++) XS[i] += XS[i-1];

    qsort(A+1, N, sizeof(A[1]), CompareY);
    for(int i=1; i<=N; i++){
        if(A[i-1][1] != A[i][1]) YL[A[i][1]] = i;
        YR[A[i][1]] = i;
        YP[i] = A[i][0];
        YS[i] = A[i][2];
    }
    for(int i=1; i<=N; i++) YS[i] += YS[i-1];

    int x = 1, y = 1;
    long long res = 0;
    for(int i=1; i<=Q; i++){
        int d, v;
        scanf("%d %d", &d, &v);
        if(d == 0) res += Get(YP, YS, YL[y], YR[y], x+1, x+v), x += v;
        if(d == 1) res += Get(XP, XS, XL[x], XR[x], y+1, y+v), y += v;
        if(d == 2) res += Get(YP, YS, YL[y], YR[y], x-v, x-1), x -= v;
        if(d == 3) res += Get(XP, XS, XL[x], XR[x], y-v, y-1), y -= v;
    }
    printf("%lld", res);
}