import java.util.*;
import java.io.*;

public class Main{
    static void init(int[][] arr, int[] pos, long[] sum){
        Arrays.sort(arr, Comparator.comparingInt(a -> a[0]));
        for(int i=0; i<arr.length; i++){
            pos[i] = arr[i][0];
            sum[i] = arr[i][1];
        }
        for(int i=1; i<arr.length; i++) sum[i] += sum[i-1];
    }

    static int lower_bound(int[] a, int v){
        int n = a.length;
        if(n == 0 || a[n-1] < v) return n;
        int l = 0, r = n - 1;
        while(l < r){
            int m = (l + r) / 2;
            if(a[m] >= v) r = m;
            else l = m + 1;
        }
        return r;
    }

    static int upper_bound(int[] a, int v){
        int n = a.length;
        if(n == 0 || a[n-1] <= v) return n;
        int l = 0, r = n - 1;
        while(l < r){
            int m = (l + r) / 2;
            if(a[m] > v) r = m;
            else l = m + 1;
        }
        return r;
    }

    static long get(int[] pos, long[] sum, int l, int r){
        int st = lower_bound(pos, l), ed = upper_bound(pos, r) - 1;
        if(st <= ed) return sum[ed] - (st > 0 ? sum[st-1] : 0);
        else return 0;
    }

    public static void main(String[] args) throws IOException {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        String[] temp = br.readLine().split(" ");
        int n = Integer.parseInt(temp[0]);
        int q = Integer.parseInt(temp[1]);

        int[] x = new int[n], y = new int[n], w = new int[n];
        int[] xcnt = new int[202020], ycnt = new int[202020];
        for(int i=0; i<n; i++){
            temp = br.readLine().split(" ");
            x[i] = Integer.parseInt(temp[0]);
            y[i] = Integer.parseInt(temp[1]);
            w[i] = Integer.parseInt(temp[2]);
            xcnt[x[i]]++; ycnt[y[i]]++;
        }

        int[][][] xv = new int[202020][][], yv = new int[202020][][];
        int[][] xp = new int[202020][], yp = new int[202020][];
        long[][] xs = new long[202020][], ys = new long[202020][];

        for(int i=0; i<202020; i++){
            xv[i] = new int[xcnt[i]][2];
            yv[i] = new int[ycnt[i]][2];
            xp[i] = new int[xcnt[i]];
            yp[i] = new int[ycnt[i]];
            xs[i] = new long[xcnt[i]];
            ys[i] = new long[ycnt[i]];
            xcnt[i] = ycnt[i] = 0;
        }

        for(int i=0; i<n; i++){
            xv[x[i]][xcnt[x[i]]][0] = y[i];
            xv[x[i]][xcnt[x[i]]][1] = w[i];
            yv[y[i]][ycnt[y[i]]][0] = x[i];
            yv[y[i]][ycnt[y[i]]][1] = w[i];
            xcnt[x[i]]++; ycnt[y[i]]++;
        }

        for(int i=0; i<202020; i++){
            init(xv[i], xp[i], xs[i]);
            init(yv[i], yp[i], ys[i]);
        }

        int x_pos = 1, y_pos = 1;
        long res = 0;
        for(int i=0; i<q; i++){
            temp = br.readLine().split(" ");
            int d = Integer.parseInt(temp[0]);
            int v = Integer.parseInt(temp[1]);
            if(d == 0){
                res += get(yp[y_pos], ys[y_pos], x_pos+1, x_pos+v);
                x_pos += v;
            }
            if(d == 1){
                res += get(xp[x_pos], xs[x_pos], y_pos+1, y_pos+v);
                y_pos += v;
            }
            if(d == 2){
                res += get(yp[y_pos], ys[y_pos], x_pos-v, x_pos-1);
                x_pos -= v;
            }
            if(d == 3){
                res += get(xp[x_pos], xs[x_pos], y_pos-v, y_pos-1);
                y_pos -= v;
            }
        }
        System.out.println(res);
        br.close();
    }
}